<?php
/*
Plugin Name:  Photos from one year ago
Version: 0.7.beta7
Description: Add a "photos from one year ago" link in "Specials" menu.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=893
Author: ddtddt
Author URI: http://temmii.com/piwigo/
*/

// +-----------------------------------------------------------------------+
// | Photos from one year ago for Piwigo by TEMMII                         |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2020 ddtddt               http://temmii.com/piwigo/ |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

defined('PHPWG_ROOT_PATH') or die('Hacking attempt!');

define('PFOYA_DIR' , basename(dirname(__FILE__)));
define('PFOYA_PATH' , PHPWG_PLUGINS_PATH .PFOYA_DIR . '/');
define('PFOYA_ADMIN' , get_root_url().'admin.php?page=plugin-'.PFOYA_DIR);

include_once(PFOYA_PATH . 'include/function.pfoya.inc.php');

add_event_handler('loading_lang', 'pfoya_loading_lang');	  
function pfoya_loading_lang(){
  load_language('plugin.lang', PFOYA_PATH);
}

  global $conf;
$confpfoya = safe_unserialize($conf['pfoya']);

//admin menu
add_event_handler('get_admin_plugin_menu_links', 'pfoya_admin_menu');

function pfoya_admin_menu($menu){
  if (is_webmaster()){
    load_language('plugin.lang', PFOYA_PATH);
    $menu[] = array(
        'NAME' => l10n('Photos from year ago'),
        'URL' => PFOYA_ADMIN,
    );
  }
     return $menu;
}

//public menu
if($confpfoya['pfoya_menu']=='link'){
add_event_handler('blockmanager_apply' , 'add_link_pfoya');
function add_link_pfoya($menu_ref_arr){
  global $conf;
  $confpfoya = safe_unserialize($conf['pfoya']);
  $menu = &$menu_ref_arr[0];
  if (($block = $menu->get_block('mbSpecials')) != null){
	array_splice($block->data, ($confpfoya['pfoya_position'])-1, 0, 
	  array('photos_from_one_year_ago' =>
		array(
		  'URL' => make_index_url(array('section' => 'photos_from_1_year_ago')),
		  'TITLE' => l10n('Displays photos from year ago'),
		  'NAME' => l10n('Photos from year ago')
		)
	  )
	);
  }
}
}else if($confpfoya['pfoya_menu']=='block'){
    add_event_handler('blockmanager_register_blocks', 'register_pfoya_menubar_blocks');
    add_event_handler('blockmanager_apply', 'pfoya_apply');

function register_pfoya_menubar_blocks($menu_ref_arr) {
    $menu = & $menu_ref_arr[0];
    if ($menu->get_id() != 'menubar')
        return;
    $menu->register_block(new RegisteredBlock('mbpfoya', 'pfoya', ('Photo from year ago')));
}

function pfoya_apply($menu_ref_arr) {
  global $template,$user;
    $menu = & $menu_ref_arr[0];
	listyearsBlock();
	$template->assign('PFOAYALINKM',make_index_url(array('section' => 'photos_from_1_year_ago')));

    if (($block = $menu->get_block('mbpfoya')) != null) {
        $template->set_template_dir(PFOYA_PATH);
		if ($user['theme'] == 'bootstrapdefault'||$user['theme'] == 'bootstrap_darkroom'){
		  $block->template = 'menubar_pfoya_bootstrap.tpl';		
		}else if ($user['theme'] == 'smartpocket'){
		  $block->template = 'menubar_pfoya_smartpocket.tpl';		
		}else if ($user['theme'] == 'modus'){
		  $block->template = 'menubar_pfoya_modus.tpl';		
		}else{
		  $block->template = 'menubar_pfoya.tpl';
		}
    }
}
}
add_event_handler('loc_end_section_init', 'section_init_pfoya');
function section_init_pfoya(){
  global $tokens, $page, $conf, $template, $user;
  $confpfoya = safe_unserialize($conf['pfoya']);
  $testurl = explode('photos_from_', $_SERVER['REQUEST_URI']);
  $template->assign('PFOAYALINK',make_index_url(array('section' => 'photos_from_1_year_ago')));
  if(!empty($testurl[1])){

    $datepfoya = $confpfoya['pfoya_dateb'];
	$daydatemax= $confpfoya['pfoya_datemax'];
	if($confpfoya['pfoya_datemax']>1 and $confpfoya['pfoya_show']==1){
		$template->assign('pfoya','a');
		listyears();
	}
	  if($testurl[1]=='1_year_ago'){
		if (!in_array('photos_from_1_year_ago', $tokens)){return;}
		  	$daydate=date("Y-m-d", strtotime('-1 year'));
		    $query = '
			  SELECT DISTINCT(i.id)
			  FROM '.IMAGES_TABLE.' AS i
				INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON i.id = ic.image_id
				INNER JOIN '.CATEGORIES_TABLE.' AS c ON ic.category_id = c.id 
				WHERE ' .  
				  get_sql_condition_FandF(
					array(
					  'forbidden_categories' => 'category_id',
					  'visible_categories' => 'category_id',
					  'visible_images' => 'image_id',
					  ),
					'', true
					);
			  $query .= '
				   and DATE ('.$datepfoya.') ="'.$daydate.'";';
		$page['section'] = 'photos_from_1_year_ago';
	    $page['title'] = '<a href="' . duplicate_index_url() . '">' . l10n('Photos from 1 year ago') . '</a>';
	    $page['section_title'] = '<a href="'.get_gallery_home_url().'">' . l10n('Home') . '</a>'
		  . $conf['level_separator'] . $page['title'];
	    $page['items'] = query2array($query, null, 'id');
		$template->assign('pfoyadata',l10n('Photos from').' '.format_date($daydate));

	  }else{
		$yurl=explode('_year_ago', $testurl[1]);
		$yurl=$yurl[0];
		if (!in_array('photos_from_'.$yurl.'_year_ago', $tokens)){return;}
		$daydate=date("Y-m-d", strtotime('-'.$yurl.' year'));
		  $query = '
		  SELECT DISTINCT(i.id)
		  FROM '.IMAGES_TABLE.' AS i
			INNER JOIN '.IMAGE_CATEGORY_TABLE.' AS ic ON i.id = ic.image_id
			INNER JOIN '.CATEGORIES_TABLE.' AS c ON ic.category_id = c.id 
			WHERE ' .  
			  get_sql_condition_FandF(
				array(
				  'forbidden_categories' => 'category_id',
				  'visible_categories' => 'category_id',
				  'visible_images' => 'image_id',
				  ),
				'', true
				);
		  $query .= '
			   and DATE ('.$datepfoya.') ="'.$daydate.'";';
		$page['section'] = 'photos_from_'.$yurl.'_year_ago';
	    $page['title'] = '<a href="' . duplicate_index_url() . '">' . l10n('Photos from %d years ago',$yurl) . '</a>';
	    $page['section_title'] = '<a href="'.get_gallery_home_url().'">' . l10n('Home') . '</a>'
		  . $conf['level_separator'] . $page['title'];
	    $page['items'] =query2array($query, null, 'id'); 
		$template->assign('pfoyadata',l10n('Photos from').' '.format_date($daydate));
	  }
	  
	
  }	
  	  if ($user['theme'] == 'bootstrapdefault'||$user['theme'] == 'bootstrap_darkroom'){
		  $template->set_filename('PFOYA', realpath(PFOYA_PATH . 'pfoya_bootstrap.tpl'));			
		}else{
		    $template->set_filename('PFOYA', realpath(PFOYA_PATH . 'pfoya.tpl'));
	  }
	

  $template->assign_var_from_handle('CONTENT', 'PFOYA');
	
}

add_event_handler('get_stuffs_modules', 'register_pfoya_module');

function register_pfoya_module($modules){
  array_push($modules, array(
    'path' => PFOYA_PATH.'/blockhome',
    'name' => l10n('Photos from 1 year ago'),
    'description' => l10n('Display X photos from 1 year ago in the gallery or a album'),
    )
  );
  return $modules;
}